package eu.etaxonomy.taxeditor.designproposal1.view;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import eu.etaxonomy.taxeditor.designproposal1.Activator;
import eu.etaxonomy.taxeditor.designproposal1.controller.OpenNameEditorAction;

public class MoveDialogView extends Dialog {

	Text searchText;
	
	private Tree tree;
	/**
	 * Create the dialog
	 * @param parentShell
	 */
	public MoveDialogView(Shell parentShell) {
		super(parentShell);
	}

	/**
	 * Create contents of the dialog
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		parent.setRedraw(true);
		Composite container = (Composite) super.createDialogArea(parent);
		final GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		container.setLayout(gridLayout);

		final Label youHaveChosenLabel = new Label(container, SWT.WRAP);
		final GridData gd_youHaveChosenLabel = new GridData(SWT.CENTER, SWT.FILL, true, false, 2, 1);
		gd_youHaveChosenLabel.heightHint = 30;
		youHaveChosenLabel.setLayoutData(gd_youHaveChosenLabel);
		youHaveChosenLabel.setText("You have chosen to turn \"Pilosella fuscoatra (Ngeli & Peter) Sojk\" into a synonym. Please choose a new accepted name from one of the following options.");

		final Group group_1 = new Group(container, SWT.NONE);
		group_1.setLayout(new GridLayout());
		final GridData gd_group_1 = new GridData(SWT.FILL, SWT.FILL, true, true);
		gd_group_1.heightHint = 83;
		group_1.setLayoutData(gd_group_1);

		final Button chooseAcceptedNameButton = new Button(group_1, SWT.RADIO);
		chooseAcceptedNameButton.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
		chooseAcceptedNameButton.setText("Choose from taxonomic tree");

		tree = new Tree(group_1, SWT.FULL_SELECTION | SWT.BORDER);
		tree.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));

		tree.setItemCount(1);
		tree.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(final MouseEvent e) {
				new OpenNameEditorAction("Pilosella").run();
			}
		});

		final TreeItem newItemTreeItem = new TreeItem(tree, SWT.NONE);
		newItemTreeItem.setChecked(true);
		newItemTreeItem.setText("Compositae Giseke");

		final TreeItem newItemTreeItem_1 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_1.setItemCount(1);
		newItemTreeItem_1.setText("Anthemideae Cass.");

		final TreeItem newItemTreeItem_2 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_2.setItemCount(1);
		newItemTreeItem_2.setText("Arctotideae Cass.");

		final TreeItem newItemTreeItem_3 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_3.setItemCount(1);
		newItemTreeItem_3.setText("Astereae Cass.");

		final TreeItem newItemTreeItem_4 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_4.setItemCount(1);
		newItemTreeItem_4.setText("Calenduleae Cass.");

		final TreeItem newItemTreeItem_5 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_5.setItemCount(1);
		newItemTreeItem_5.setText("Cardueae Cass.");

		final TreeItem newItemTreeItem_6 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_6.setText("Cichorieae Lam. & DC.");

		final TreeItem newItemTreeItem_16 = new TreeItem(newItemTreeItem_6, SWT.NONE);
		newItemTreeItem_16.setExpanded(true);
		newItemTreeItem_16.setText("Pilosella Vaill.");

		final TreeItem newItemTreeItem_17 = new TreeItem(newItemTreeItem_16, SWT.NONE);
		newItemTreeItem_17.setText("Pilosella fuscoatra coll.");

		final TreeItem newItemTreeItem_18 = new TreeItem(newItemTreeItem_17, SWT.NONE);
		newItemTreeItem_18.setFont(SWTResourceManager.getFont("", 8, SWT.BOLD));
		newItemTreeItem_18.setExpanded(true);
		newItemTreeItem_18.setText("Pilosella fuscoatra (Ngeli & Peter) Sojk");

		final TreeItem newItemTreeItem_7 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_7.setItemCount(1);
		newItemTreeItem_7.setText("Eupatorieae Cass.");

		final TreeItem newItemTreeItem_8 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_8.setItemCount(1);
		newItemTreeItem_8.setText("Gnaphalieae Lecoq & Juillet");

		final TreeItem newItemTreeItem_9 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_9.setItemCount(1);
		newItemTreeItem_9.setText("Helenieae Lindl.");

		final TreeItem newItemTreeItem_10 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_10.setItemCount(1);
		newItemTreeItem_10.setText("Heliantheae Cass.");

		final TreeItem newItemTreeItem_11 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_11.setItemCount(1);
		newItemTreeItem_11.setText("Inuleae Cass.");

		final TreeItem newItemTreeItem_12 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_12.setItemCount(1);
		newItemTreeItem_12.setText("Mutisieae Cass.");

		final TreeItem newItemTreeItem_13 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_13.setItemCount(1);
		newItemTreeItem_13.setText("Plucheeae Anderb.");

		final TreeItem newItemTreeItem_14 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_14.setItemCount(1);
		newItemTreeItem_14.setText("Senecioneae Cass.");

		final TreeItem newItemTreeItem_15 = new TreeItem(newItemTreeItem, SWT.NONE);
		newItemTreeItem_15.setItemCount(1);
		newItemTreeItem_15.setText("Vernonieae Cass.");

		final Composite composite = new Composite(container, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		composite.setLayout(new FillLayout(SWT.VERTICAL));
		
		final Group group = new Group(composite, SWT.NONE);
		group.setLayout(new GridLayout());

		final Button chooseAcceptedTaxonButton = new Button(group, SWT.RADIO);
		chooseAcceptedTaxonButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
			}
		});
		chooseAcceptedTaxonButton.setText("Choose from recently viewed taxa");

		
		
		
		
		Table table = new Table(group, SWT.BORDER);
		table.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(final MouseEvent e) {
				new OpenNameEditorAction("Carduus").run();
			}
		});
		table.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));

		final TableItem newItemTableItem = new TableItem(table, SWT.BORDER);
		newItemTableItem.setText("Laphangium (Hilliard & B. L. Burtt) Tzvelev");

		final TableItem newItemTableItem_1 = new TableItem(table, SWT.BORDER);
		newItemTableItem_1.setText("Carduus L.");

		final TableItem newItemTableItem_2 = new TableItem(table, SWT.BORDER);
		newItemTableItem_2.setText("Carduus carpetanus Boiss. & Reut.");

		final TableItem newItemTableItem_3 = new TableItem(table, SWT.BORDER);
		newItemTableItem_3.setText("Carduus kerneri Simonk.");

		final TableItem newItemTableItem_5 = new TableItem(table, SWT.BORDER);
		newItemTableItem_5.setText("Senecio eboracensis R. J. Abbott & A. J. Lowe");

		final TableItem newItemTableItem_6 = new TableItem(table, SWT.BORDER);
		newItemTableItem_6.setText("Senecio elegans L.");		
		
		final Group group_2 = new Group(composite, SWT.NONE);
		final GridLayout gridLayout_1 = new GridLayout();
		gridLayout_1.numColumns = 2;
		group_2.setLayout(gridLayout_1);

		final Button searchForNameButton = new Button(group_2, SWT.RADIO);
		searchForNameButton.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false));
		searchForNameButton.setText("Search for name of accepted taxon");
		new Label(group_2, SWT.NONE);
		
		searchText = new Text(group_2, SWT.BORDER);
		searchText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
		searchText.setForeground(SWTResourceManager.getColor(192, 192, 192));
		searchText.setText("Use \"*\" for wildcard searching");
		searchText.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				searchText.setForeground(SWTResourceManager.getColor(0,0,0));
				searchText.setText("");
			}

			public void focusLost(FocusEvent e) {
				if (searchText.getText() == "") {
					searchText.setForeground(SWTResourceManager.getColor(192, 192, 192));
					searchText.setText("Use \"*\" for wildcard searching");					
				}
				
			}
			
		});

		final Button searchButton = new Button(group_2, SWT.NONE);
		searchButton.setLayoutData(new GridData());
		searchButton.setText("Search");

		final Composite composite_1 = new Composite(container, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 2, 1));
		composite_1.setLayout(new FillLayout());

		final Label selectedTaxonLabel = new Label(composite_1, SWT.NONE);
		selectedTaxonLabel.setText("Selected taxon: ");

		final Label currentSelectionSenecioLabel = new Label(composite_1, SWT.RIGHT);
		currentSelectionSenecioLabel.setFont(SWTResourceManager.getFont("", 9, SWT.BOLD));
		currentSelectionSenecioLabel.setText("Senecio elegans L.");
		new Label(container, SWT.NONE);
		
		
		//
		return container;
	}

	/**
	 * Create contents of the button bar
	 * @param parent
	 */
	@Override
	protected void createButtonsForButtonBar(Composite parent) {
		createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL,
				true);
		createButton(parent, IDialogConstants.CANCEL_ID,
				IDialogConstants.CANCEL_LABEL, false);
	}

	/**
	 * Return the initial size of the dialog
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(700, 500);
	}
	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/edit_16x16.ico"));
		newShell.setText("Move \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
	}

}
