package eu.etaxonomy.taxeditor.prototype1.model;

public class TaxonName extends AbstractModelObject {
	private String genus;
	private String speciesEpithet;
	private String authorship;
	private String name;
	public TaxonName (String genus,
				String speciesEpithet,
				String authorship) {
		this.genus = genus;
		this.speciesEpithet = speciesEpithet;
		this.authorship = authorship;
		setName();
	}
	public String getName() {
		return name;
	}
	public void setName(String newName) {
		String oldName = this.name;
		this.name = newName;
		firePropertyChange("name", oldName, newName);
	}
	public void setName() {
		setName(this.genus + " " + this.speciesEpithet);
	}
	
	public String getGenus() {
		return genus;
	}
	public void setGenus(String genus) {
		this.genus = genus;
	}
	public String getSpeciesEpithet() {
		return speciesEpithet;
	}
	public void setSpeciesEpithet(String speciesEpithet) {
		this.speciesEpithet = speciesEpithet;
	}
	public String getAuthorship() {
		return authorship;
	}
	public void setAuthorship(String authorship) {
		this.authorship = authorship;
	}
}
