package eu.etaxonomy.taxeditor.prototype2.controller;

import org.eclipse.jface.action.Action;

import eu.etaxonomy.cdm.model.name.BotanicalName;
import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.SynonymRelationshipType;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.prototype2.view.nameviewersupport.TesterooWritableSet;

/**
 * Add a new synonym to a taxon.
 * 
 * @author p.ciardelli
 *
 */
public class ActionAddSynonymToTaxon extends Action {
	Taxon taxon;
	Synonym synonym;
	
	public ActionAddSynonymToTaxon(Taxon taxon, Synonym synonym) {
		this.taxon = taxon;
		this.synonym = synonym;
	}

	public ActionAddSynonymToTaxon(Taxon taxon, String synonymNameCache) {
		this.taxon = taxon;
		this.synonym = new Synonym();
		this.synonym.setName(BotanicalName.PARSED_NAME(synonymNameCache));
	}	

	public void run() {
		taxon.addSynonym(synonym, SynonymRelationshipType.HETEROTYPIC_SYNONYM_OF());
//		taxon.removeSynonymRelation(synonym.getSynonymRelations()[0]);
				
		TesterooWritableSet.getInstance().add(synonym);
	}
}