/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.actions.name;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.operations.IUndoableOperation;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;

import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.ITaxEditorConstants;
import eu.etaxonomy.taxeditor.TaxEditorPlugin;
import eu.etaxonomy.taxeditor.controller.EditorController;
import eu.etaxonomy.taxeditor.controller.GlobalController;
import eu.etaxonomy.taxeditor.operations.name.UnmakeSynonymGroupBasionymOperation;

/**
 * @author n.hoffmann
 * @created 03.02.2009
 * @version 1.0
 */
public class UnmakeBasionymAction extends Action {
	private static final Logger logger = Logger
			.getLogger(UnmakeBasionymAction.class);
	
	
	private static ImageDescriptor image = TaxEditorPlugin.getDefault()
		.getImageDescriptor(ITaxEditorConstants.BASIONYM_ICON);
	
	private Taxon taxon;
	private Synonym synonym;
	
	public UnmakeBasionymAction(Taxon taxon, Synonym synonym){
		String text = Messages.getString("RemoveBasionymCompositeAction.0", synonym.getName());  //$NON-NLS-1$
		this.setText(text);
		this.setImageDescriptor(image);
		this.taxon = taxon;
		this.synonym = synonym;
	}
	
	@Deprecated
	public void run() {
		IUndoableOperation operation = new UnmakeSynonymGroupBasionymOperation
				(this.getText(), EditorController.getUndoContext(taxon), taxon, synonym);
		
		GlobalController.executeOperation(operation);				
	}
}
