/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.actions.ui;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.operations.IUndoableOperation;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.PartInitException;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.ITaxEditorConstants;
import eu.etaxonomy.taxeditor.TaxEditorPlugin;
import eu.etaxonomy.taxeditor.actions.cdm.MoveTaxonAction;
import eu.etaxonomy.taxeditor.controller.EditorController;
import eu.etaxonomy.taxeditor.controller.GlobalController;
import eu.etaxonomy.taxeditor.editor.SelectTaxonDialog;
import eu.etaxonomy.taxeditor.model.NameEditorInput;
import eu.etaxonomy.taxeditor.operations.MoveTaxonOperation;

/**
 * @author p.ciardelli
 * @created 26.05.2008
 * @version 1.0
 */
public class MoveTaxonDialogAction extends Action {
	private static final Logger logger = Logger
			.getLogger(MoveTaxonDialogAction.class);

	private static String text = "Move this taxon to a new parent";
	private static ImageDescriptor image = TaxEditorPlugin.getDefault()
			.getImageRegistry().getDescriptor(ITaxEditorConstants.MOVE_ICON);

	public MoveTaxonDialogAction() {
		super(text, image);
	}

	@Deprecated
	public void run() {
		
		Taxon taxon = EditorController.getActiveEditor().getTaxon();
		IEditorPart editor = null;
		

		// TODO? Prompt user "Would you like to save?" before showing dialog
		// "Cancel" cancels action - "No" does not
		if (EditorController.save(taxon, true) == false) {
			return;
		}
		
		// Get destination taxon from dialog
		SelectTaxonDialog dialog = new SelectTaxonDialog(GlobalController.getShell(), 
										SelectTaxonDialog.TAXON_TO_NEW_PARENT);
		Taxon destinationTaxon = dialog.open(taxon);
		
		// Abort action if user cancelled dialog without choosing a taxon
		if (destinationTaxon == null) {
			return;
		}
				
		// Move taxon in CDM
		IUndoableOperation operation = new MoveTaxonOperation(this.getText(), 
				GlobalController.getWorkbenchUndoContext(), taxon, destinationTaxon);
		
		GlobalController.executeOperation(operation);
		
		// For some reason, old parent is not getting the hint that one of its children is gone
//		new SaveTaxonAction(oldParent).run();
//		new SaveTaxonAction(destinationTaxon).run();
		
		editor.doSave(null);
	}
}