/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.propertysheet;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.ICellEditorValidator;

/**
 * @author p.ciardelli
 * @created 11.11.2008
 * @version 1.0
 */
public class DayValidator implements ICellEditorValidator {
	private static final Logger logger = Logger.getLogger(DayValidator.class);

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ICellEditorValidator#isValid(java.lang.Object)
	 */
	
	public String isValid(Object value) {
		
		String msg = "Value in day field must be an integer between 1-31."; 
		
		if (((String) value).equals("")) {
			return null;
		}
		
		Integer day = 0;
		try {
			day = new Integer((String) value);
		} catch (ClassCastException e) {
			return msg;
		} catch (NumberFormatException e) {
			return msg;
		}

		if (day == 0 || day > 31) {
			return msg;
		}
		
		return null;
	}
}
