package eu.etaxonomy.taxeditor;

import org.eclipse.jface.action.IMenuManager;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.application.ActionBarAdvisor;
import org.eclipse.ui.application.IActionBarConfigurer;

import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.navigation.NavigationUtil;

/**
 * An action bar advisor is responsible for creating, adding, and disposing of
 * the actions added to a workbench window. Each window will be populated with
 * new actions.
 */
public class ApplicationActionBarAdvisor extends ActionBarAdvisor {

	public ApplicationActionBarAdvisor(IActionBarConfigurer configurer) {
		super(configurer);
	}

	protected void makeActions(final IWorkbenchWindow window) {
		NavigationUtil.setStatusLineManager(getActionBarConfigurer().getStatusLineManager());
		EditorUtil.setStatusLineManager(getActionBarConfigurer().getStatusLineManager());
	}

	protected void fillMenuBar(IMenuManager menuBar) {
	}

}
