// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor;

import eu.etaxonomy.taxeditor.editor.description.TaxonDescriptionEditor;
import eu.etaxonomy.taxeditor.editor.images.TaxonImageEditor;
import eu.etaxonomy.taxeditor.editor.name.TaxonNameEditor;

/**
 * @author n.hoffmann
 * @created 30.04.2009
 * @version 1.0
 */
public enum Page {
	NAME ("Name", TaxonNameEditor.class, 0), 
	DESCRIPTIVE ("Descriptive", TaxonDescriptionEditor.class, 1),
	IMAGE ("Image", TaxonImageEditor.class, 2);
	
	private String title;
	private Class<?> clazz;
	private int index;
	
	Page(String title, Class<?> clazz, int index){
		this.title = title;
		this.clazz = clazz;
		this.index = index;
	}
	
	public String getTitle(){
		return this.title;
	}
	
	public Class<?> getClazz(){
		return this.clazz;
	}
	
	public int getIndex(){
		return this.index;
	}
}
