/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.editor;

import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;

/**
 * Passes modified text to the method <code>parse</code>. 
 * 
 * @author p.ciardelli
 * @created 02.06.2008
 * @version 1.0
 */
public abstract class ParseListener implements ModifyListener {

	public void modifyText(ModifyEvent e) {
		StyledText widget = (StyledText) e.widget;
		String text = widget.getText();
		parse(text);
	}
	
	abstract public void parse(String text);
}
