// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.name;

import java.util.List;

import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author p.ciardelli
 * @created 08.05.2009
 * @version 1.0
 */
public class TaxonSearchDialog extends NameSearchDialog {
	
	protected String dialogTitle = "Search for a taxib in datasource";
	protected String dialogMessage = "Enter a search term for a taxon, using '*' as a wildcard.";

	private Taxon taxon;
	private Taxon excludeTaxon;
	
	/**
	 * @param parent
	 */
	public TaxonSearchDialog(Shell parent) {
		super(parent);
	}

	/**
	 * @param parent
	 */
	public TaxonSearchDialog(Shell parent, Taxon excludeTaxon) {
		super(parent);
		
		this.excludeTaxon = excludeTaxon;
	}
	
	protected List<?> doSearch() {
		List<?> results = CdmStore.searchTaxaByName(searchTermText.getText(), true);
		if (excludeTaxon != null) {
			results.remove(excludeTaxon);
		}
		return results;
	}
	
	/**
	 * @param element
	 */
	protected String getText(Object element) {
		if (element instanceof Taxon) {
			return ((Taxon) element).getTitleCache();
		}
		return null;
	}
	
	/**
	 * @param data
	 * @return
	 */
	protected boolean setSelection(Object data) {
		if (data instanceof Taxon) {
			setSelectedTaxon((Taxon) data);	
			return true;
		}
		return false;
	}

	/**
	 * @param data
	 */
	private void setSelectedTaxon(Taxon taxon) {
		this.taxon = taxon;
	}

	/**
	 * @return
	 */
	private Object getSelectedTaxon() {
		return taxon;
	}
	
	protected void submitResult() {
		result = getSelectedTaxon();
		shell.dispose();
	}
}