package eu.etaxonomy.taxeditor.propertysheet;

import java.util.Collection;

import eu.etaxonomy.cdm.model.common.Annotation;

public class AnnotationPropertySource extends CollectionPropertySource {

	public AnnotationPropertySource(Collection<?> collection) {
		super(collection);
	}
	
	@Override
	protected String getItemDisplayName(Object item) {
		// No display names on individual annotations
		return "";
	}

	@Override
	public Object getPropertyValue(Object id) {
		if (id instanceof Annotation) {
			return ((Annotation) id).getText();
		}
		return null;
	}

	@Override
	public void setPropertyValue(Object id, Object value) {
		// Fields not editable in property sheet view
	}

	@Override
	public String toString() {
		// "Annotations" header has no value
		return "";
	}
}