// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.propertysheet.description;

import org.apache.log4j.Logger;
import org.eclipse.ui.views.properties.PropertyDescriptor;

import eu.etaxonomy.cdm.model.description.Distribution;

/**
 * @author p.ciardelli
 * @created 02.04.2009
 * @version 1.0
 */
public class DistributionPropertySource extends DescriptionElementPropertySource {
	private static final Logger logger = Logger
			.getLogger(DistributionPropertySource.class);

	public static final String P_ID_NAMED_AREA = "named area";
	public static final String P_NAMED_AREA = "Named Area";
	
	public static final String P_ID_STATUS = "status";
	public static final String P_STATUS = "Status";

	private Distribution distribution;
	
	/**
	 * @param element
	 */
	public DistributionPropertySource(Distribution distribution) {
		super(distribution);
		
		this.distribution = distribution;
		addDescriptor(P_ID_NAMED_AREA);
		addDescriptor(P_ID_STATUS);
	}
	
	protected void addDescriptor(String id) {
		super.addDescriptor(id);
		
		if (id.equals(P_ID_NAMED_AREA)) {
			descriptors.addElement(
					new PropertyDescriptor(P_ID_NAMED_AREA, P_NAMED_AREA)
			);
		}
		
		if (id.equals(P_ID_STATUS)) {
			descriptors.addElement(
					new PropertyDescriptor(P_ID_STATUS, P_STATUS)
			);
		}
	}
	


	public Object getPropertyValue(Object id) {
		
		if (id.equals(P_ID_NAMED_AREA)) {
			return distribution.getArea().getLabel();
		}
		
		if (id.equals(P_ID_STATUS)) {
			return distribution.getStatus().getLabel();
		}
		
		return super.getPropertyValue(id);
	}
}