/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.propertysheet.name;

import java.util.Collection;

import eu.etaxonomy.cdm.model.name.NomenclaturalStatus;
import eu.etaxonomy.cdm.model.name.NomenclaturalStatusType;
import eu.etaxonomy.taxeditor.propertysheet.CollectionPropertySource;

/**
 * @author p.ciardelli
 * @created 15.05.2008
 * @version 1.0
 */
public class NomStatusPropertySource extends CollectionPropertySource {

	public NomStatusPropertySource(Collection<?> collection) {
		super(collection);
	}

	static NomenclaturalStatusType[] nomStatusTypes = null;
	static String[] P_NOMSTATUS_MENU = null;		
	

	@Override
	protected String getItemDisplayName(Object item) {
		// No display names on individual nom statii
		return "";
	}

	@Override
	public Object getPropertyValue(Object id) {
		if (id instanceof NomenclaturalStatus) {
			NomenclaturalStatus nomenclaturalStatus = (NomenclaturalStatus) id;
			NomenclaturalStatusType statusType = nomenclaturalStatus.getType(); 
			if (statusType != null) {
				return statusType.getLabel();
			}
		}
		return null;
	}

	@Override
	public void setPropertyValue(Object id, Object value) {
		// Fields not editable in property sheet view	
	}

	@Override
	public String toString() {
		// "Nom. Status" header has no value
		return "";
	}
}