// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.navigation.navigator;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.StyledString;
import org.eclipse.jface.viewers.DelegatingStyledCellLabelProvider.IStyledLabelProvider;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.navigator.IDescriptionProvider;

import eu.etaxonomy.cdm.model.taxon.Synonym;

/**
 * @author p.ciardelli
 * @created 02.06.2009
 * @version 1.0
 */
/**
 * @author p.ciardelli
 * @created 04.06.2009
 * @version 1.0
 */
public class NavigatorSynonymLabelProvider extends ColumnLabelProvider 
		implements ILabelProvider, IDescriptionProvider, IStyledLabelProvider {
	private static final Logger logger = Logger
			.getLogger(NavigatorSynonymLabelProvider.class);
	
	public Image getImage(Object element) {
		return null;
	}

	public String getText(Object element) {
		if (element instanceof Synonym &&
				((Synonym) element).getName() != null) {
			
			return "= " + ((Synonym) element).getName().getTitleCache();
		}
		return new String();
	}	
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.navigator.IDescriptionProvider#getDescription(java.lang.Object)
	 */
	public String getDescription(Object anElement) {
		if (anElement instanceof Synonym) {
			Synonym data = (Synonym) anElement;
			return "Synonym: " + data.getTitleCache(); //$NON-NLS-1$
		}
		return null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.DelegatingStyledCellLabelProvider.IStyledLabelProvider#getStyledText(java.lang.Object)
	 */
	public StyledString getStyledText(Object element) {
		return new StyledString(getText(element), StyledString.QUALIFIER_STYLER);
	}
}
