// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.navigation.navigator;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import eu.etaxonomy.cdm.model.taxon.Taxon;

/**
 * @author p.ciardelli
 * @created 02.06.2009
 * @version 1.0
 */
public class NavigatorTaxonContentProvider implements ITreeContentProvider {
	private static final Logger logger = Logger
			.getLogger(NavigatorTaxonContentProvider.class);

	public Object[] getChildren(Object parentElement) {
		
		if (parentElement instanceof NavigatorRoot) {
			return ((NavigatorRoot) parentElement).getParentBeans().toArray();
		}
		
		if (parentElement instanceof Taxon) {
			return ((Taxon) parentElement).getTaxonomicChildren().toArray();
		}
		
		return new Object[0];
	}

	public Object getParent(Object element) {
		return null;
	}

	public boolean hasChildren(Object element) {
		return this.getChildren(element).length > 0;
	}

	public Object[] getElements(Object inputElement) {
		return this.getChildren(inputElement);
	}

	public void dispose() {
	}

	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}
}
