/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.navigation.taxonomictree;

import org.apache.log4j.Logger;

import eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeMap;
import eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeEvent.EventType;
import eu.etaxonomy.taxeditor.store.model.AbstractDataChangeBehaviour;
import eu.etaxonomy.taxeditor.store.model.IDataChangeBehavior;

/**
 * @author n.hoffmann
 * @created 01.04.2009
 * @version 1.0
 */
@Deprecated public class TaxonomicTreeViewDataChangeBehaviour extends AbstractDataChangeBehaviour implements 
		IDataChangeBehavior {
	private static final Logger logger = Logger
			.getLogger(TaxonomicTreeViewDataChangeBehaviour.class);

	private TaxonomicTreeView source;
	
	public TaxonomicTreeViewDataChangeBehaviour(
			TaxonomicTreeView taxonomicTreeView) {
		source = taxonomicTreeView;
	}

	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.store.model.IDataChangeBehavior#isRelevant(java.lang.Object, eu.etaxonomy.cdm.persistence.hibernate.CdmCrudEvent)
	 */
	public boolean isRelevant(CdmDataChangeMap events) {
		// react on everything except load
		if(events.sizeByEventType(EventType.INSERT) > 0){
			return true;
		}else if(events.sizeByEventType(EventType.UPDATE) > 0){
			return true;
		}else if(events.sizeByEventType(EventType.DELETE) > 0){
			return true;
		}else{
			return false;
		}
	}


	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.store.model.IDataChangeBehavior#reactOnDataChange(java.lang.Object, eu.etaxonomy.cdm.persistence.hibernate.CdmCrudEvent)
	 */
	public void reactOnDataChange(CdmDataChangeMap events) {


		if(isRelevant(events)){
			
			source.refresh();
			
			logger.info("DataStore update caused a refresh of the taxonomic tree");

		}
	}
}
