// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.store.datasource.handler;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import eu.etaxonomy.taxeditor.store.datasource.view.CdmDataSourceView;

/**
 * @author n.hoffmann
 * @created 19.05.2009
 * @version 1.0
 */
abstract class AbstractDataSourceHandler extends AbstractHandler {
	private static final Logger logger = Logger
			.getLogger(AbstractDataSourceHandler.class);

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		
		specificExecute(event);
		
		try {
			CdmDataSourceView view = (CdmDataSourceView) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView(CdmDataSourceView.ID);
			view.refresh();
		} catch (PartInitException e) {
			logger.error("Could not refresh DataSourceView", e);
		} 
		
		return null;
	}
	
	public abstract Object specificExecute(ExecutionEvent event);
}
