// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.store.datasource.handler;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.cdm.database.ICdmDataSource;
import eu.etaxonomy.taxeditor.store.datasource.wizard.CdmDataSourceWizard;

/**
 * @author n.hoffmann
 * @created 15.04.2009
 * @version 1.0
 */
public class EditDataSourceHandler extends AbstractDataSourceHandler {

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.store.datasource.handler.AbstractDataSourceHandler#specificExecute(org.eclipse.core.commands.ExecutionEvent)
	 */
	@Override
	public Object specificExecute(ExecutionEvent event) {
		ISelection menuSelection = HandlerUtil.getActiveMenuSelection(event);
		ICdmDataSource dataSource = (ICdmDataSource) ((StructuredSelection) menuSelection).getFirstElement();

		CdmDataSourceWizard wizard = new CdmDataSourceWizard(dataSource);
		WizardDialog dialog = new WizardDialog(HandlerUtil.getActiveShell(event), wizard);
	    dialog.open();
	    
	    return null;
	}
}
