// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.store.datasource.view;

import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

import eu.etaxonomy.cdm.database.ICdmDataSource;
import eu.etaxonomy.taxeditor.store.datasource.CdmDataSourceRepository;
import eu.etaxonomy.taxeditor.store.model.ImageResources;

/**
 * @author n.hoffmann
 * @created 14.04.2009
 * @version 1.0
 */
public class CdmDataSourceLabelProvider extends LabelProvider implements ITableLabelProvider {

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnImage(java.lang.Object, int)
	 */
	public Image getColumnImage(Object element, int columnIndex) {
		// No image at the moment.
		// TODO display image in colum 0 if the datasource is connected
		if(columnIndex == 0){
			ICdmDataSource dataSource = (ICdmDataSource) element;
			String key = isCurrentDataSource(dataSource) ? ImageResources.IMG_DATASOURCE_CONNECTED : ImageResources.IMG_DATASOURCE_DISCONNECTED;
			
			return ImageResources.getImage(key);
		}
		
		return null;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object, int)
	 */
	public String getColumnText(Object element, int columnIndex) {
		ICdmDataSource dataSource = (ICdmDataSource) element;
		switch (columnIndex){
//			case 0:
//				return isCurrentDataSource(dataSource) ? "Y" : "N"; 
			case 1:
				return dataSource.getName();
			case 2:
				if(dataSource.getServer() != null){
					// true for h2 databases
					return dataSource.getServer();
				}
				return "local";
			case 3:
				return dataSource.getDatabaseType().getName();
		}
		return null;
	}
	
	private boolean isCurrentDataSource(ICdmDataSource dataSource){
		String current = CdmDataSourceRepository.getDefault().getCurrentDataSource().getName();
		return current.equals(dataSource.getName());
	}
}
