/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.store.operations;

import eu.etaxonomy.cdm.model.common.CdmBase;



/**
 * Implementors may register to operations. The postOperation method will
 * get called after any post operation
 * 
 * @author n.hoffmann
 * @created 24.03.2009
 * @version 1.0
 */
public interface IPostOperationEnabled {
	
	/**
	 * This method will be called after executing an operation.
	 * If operation created a new object and the registrar has to know about the 
	 * oBject it should be passed to the registrar 
	 * @param objectAffectedByOperation an occasional newly created object. May be <code>null</code>
	 * 
	 * @return true the method executed succesfully
	 */
	public boolean postOperation(CdmBase objectAffectedByOperation);
}
